diff options
author | intrigeri <intrigeri@boum.org> | 2012-05-15 17:55:51 +0200 |
---|---|---|
committer | intrigeri <intrigeri@boum.org> | 2012-05-15 17:55:51 +0200 |
commit | ad63b8a78b728bf7e2c479e5e26fb4ed9b6d66bf (patch) | |
tree | 392f8d082fb3fc26e1ea30c483c0e19a90f5f7f7 /handlers/ldap.in | |
parent | 1b2dc55cb82d790eca8ea1c2b325a755db75a91a (diff) | |
parent | 13edaf0912f8b36d5035b5ebdbbc28fd0d498427 (diff) | |
download | backupninja-ad63b8a78b728bf7e2c479e5e26fb4ed9b6d66bf.tar.gz backupninja-ad63b8a78b728bf7e2c479e5e26fb4ed9b6d66bf.tar.bz2 |
Merge tag 'backupninja_upstream/1.0_rc1' into debian
Upstream version 1.0~rc1
Conflicts:
Makefile.in
aclocal.m4
configure
etc/Makefile.in
examples/Makefile.in
handlers/Makefile.in
install-sh
lib/Makefile.in
man/Makefile.in
missing
src/Makefile.in
Diffstat (limited to 'handlers/ldap.in')
-rw-r--r-- | handlers/ldap.in | 112 |
1 files changed, 0 insertions, 112 deletions
diff --git a/handlers/ldap.in b/handlers/ldap.in deleted file mode 100644 index 600f172..0000000 --- a/handlers/ldap.in +++ /dev/null @@ -1,112 +0,0 @@ -# -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*- -# vim: set filetype=sh sw=3 sts=3 expandtab autoindent: -# -# openldap backup handler script for backupninja -# - -getconf backupdir /var/backups/ldap -getconf conf /etc/ldap/slapd.conf -getconf databases all -getconf compress yes -getconf ldif yes -getconf restart no -getconf method ldapsearch -getconf passwordfile -getconf binddn -getconf ldaphost -getconf ssl yes -getconf tls no - -if [ $ssl = 'yes' ]; then - URLBASE="ldaps" -else - URLBASE="ldap" -fi - -status="ok" - -[ -f $conf ] || fatal "slapd config file ($conf) not found" -[ -d $backupdir ] || mkdir -p $backupdir -[ -d $backupdir ] || fatal "Backup directory '$backupdir'" - -dbsuffixes=(`@AWK@ 'BEGIN {OFS=":"} /[:space:]*^database[:space:]*\w*/ {db=$2}; /^[:space:]*suffix[:space:]*\w*/ {if (db=="bdb"||db=="hdb"||db="ldbm") print db,$2}' $conf|@SED@ -e 's/[" ]//g'`) - -## LDIF DUMP - -if [ "$ldif" == "yes" ]; then - dumpdir="$backupdir" - [ -d $dumpdir ] || mkdir -p $dumpdir - - if [ "$databases" == 'all' ]; then - dbcount=`grep '^database' $conf | wc -l` - let "dbcount = dbcount - 1" - databases=`seq 0 $dbcount`; - fi - - for db in $databases; do - if [ `expr index "$db" "="` == "0" ]; then - # db is a number, get the suffix. - dbsuffix=${dbsuffixes[$db]/*:/} - else - dbsuffix=$db - fi - # some databases don't have suffix (like monitor), skip these - if [ "$dbsuffix" == "" ]; then - continue; - fi - - if [ "$method" == "slapcat" ]; then - execstr="$SLAPCAT -f $conf -b $dbsuffix" - else - LDAPARGS="" - if [ "$tls" == "yes" ]; then - LDAPARGS="-ZZ" - fi - if [ -n "$ldaphost" ]; then - execstr="$LDAPSEARCH $LDAPARGS -H $URLBASE://$ldaphost -x -L -b ""$dbsuffix"" -D ""$binddn"" -y $passwordfile" - else - execstr="$LDAPSEARCH -H $URLBASE://$ldaphost -x -L -b ""$dbsuffix"" -D ""$binddn"" -y $passwordfile" - fi - [ -f "$passwordfile" ] || fatal "Password file $passwordfile not found. When method is set to ldapsearch, you must also specify a password file." - debug "$execstr" - fi - if [ ! $test ]; then - if [ "$restart" == "yes" ]; then - debug "Shutting down ldap server..." - /etc/init.d/slapd stop - fi - - ext= - if [ "$compress" == "yes" ]; then - ext=".gz" - fi - touch $dumpdir/$dbsuffix.ldif$ext - if [ ! -f $dumpdir/$dbsuffix.ldif$ext ]; then - fatal "Couldn't create ldif dump file: $dumpdir/$dbsuffix.ldif$ext" - fi - - if [ "$compress" == "yes" ]; then - execstr="$execstr | $GZIP $GZIP_OPTS > $dumpdir/$dbsuffix.ldif.gz" - else - execstr="$execstr > $dumpdir/$dbsuffix.ldif" - fi - debug "$execstr" - output=`su root -s /bin/bash -c "set -o pipefail ; $execstr" 2>&1` - code=$? - if [ "$code" == "0" ]; then - debug $output - info "Successfully finished ldif export of $dbsuffix" - else - warning $output - warning "Failed ldif export of $dbsuffix" - fi - - if [ "$restart" == "yes" ]; then - debug "Starting ldap server..." - /etc/init.d/slapd start - fi - fi - done -fi - -return 0 |